<?php
require_once 'Mage/Catalog/controllers/CategoryController.php';

class Qian_Rcah_IndexController extends Mage_Catalog_CategoryController
{
    protected function _initCatagory()
    {
        Mage::dispatchEvent('catalog_controller_category_init_before', array('controller_action'=>$this));
        $rootCategoryId = Mage::app()->getStore()->getRootCategoryId();
        $categoryId = (int) $this->getRequest()->getParam('id', $rootCategoryId);
        if (!$categoryId) {
            return false;
        }

        $category = Mage::getModel('catalog/category')
            ->setStoreId(Mage::app()->getStore()->getId())
            ->load($categoryId);

        if ($categoryId == $rootCategoryId) {
        	//do nothing. bypass canshow test for root category
        }
        elseif (!Mage::helper('catalog/category')->canShow($category)) {
            return false;
        }
        Mage::getSingleton('catalog/session')->setLastVisitedCategoryId($category->getId());
        Mage::register('current_category', $category);
        try {
            Mage::dispatchEvent('catalog_controller_category_init_after', array('category'=>$category, 'controller_action'=>$this));
        } catch (Mage_Core_Exception $e) {
            Mage::logException($e);
            return false;
        }
        return $category;
    }

    public function indexAction()
    {
    	$this->_forward('view', null, null, $this->getRequest()->getParams());
    }
}